#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const argv_1 = require("./argv");
(() => __awaiter(void 0, void 0, void 0, function* () {
    const { filePath, uri, sourceUri, targetUri, pattern, useTtl, bulkSize } = argv_1.argv;
    switch (argv_1.command) {
        case 'dump':
            (0, utils_1.dump)({ filePath, uri, pattern, bulkSize });
            break;
        case 'restore':
            (0, utils_1.restore)({ filePath, uri, bulkSize, useTtl });
            break;
        case 'sync':
            (0, utils_1.sync)({
                sourceUri,
                targetUri,
                pattern,
                bulkSize,
                useTtl,
            });
            break;
        default:
            break;
    }
}))();
//# sourceMappingURL=cli.js.map