"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sync = exports.restore = exports.dump = exports.progressBar = void 0;
const progress_1 = __importDefault(require("progress"));
const index_1 = require("../index");
const IRedisDRS = __importStar(require("./model"));
const progressBar = (type, total) => {
    return new progress_1.default(`[${type}] Progress [:bar] :rate/s :percent :etas`, {
        complete: '=',
        incomplete: ' ',
        width: 50,
        total,
    });
};
exports.progressBar = progressBar;
const dump = (options) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, e_1, _b, _c;
    const { filePath, uri: path, pattern, bulkSize, logger, } = new IRedisDRS.dump(options);
    const redis = new index_1.RedisDRS({ path, logger });
    const data = yield redis.dump({ filePath, pattern, bulkSize });
    const total = (yield data.next()).value;
    const progress = (0, exports.progressBar)('DUMP', total);
    try {
        for (var _d = true, data_1 = __asyncValues(data), data_1_1; data_1_1 = yield data_1.next(), _a = data_1_1.done, !_a;) {
            _c = data_1_1.value;
            _d = false;
            try {
                const val = _c;
                progress === null || progress === void 0 ? void 0 : progress.tick();
            }
            finally {
                _d = true;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (!_d && !_a && (_b = data_1.return)) yield _b.call(data_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    redis.disconnect();
});
exports.dump = dump;
const restore = (options) => __awaiter(void 0, void 0, void 0, function* () {
    var _e, e_2, _f, _g;
    const { filePath, uri: path, useTtl, bulkSize, logger, } = new IRedisDRS.restore(options);
    const redis = new index_1.RedisDRS({ path, logger });
    const data = yield redis.restore({ filePath, useTtl, bulkSize });
    const total = (yield data.next()).value;
    const progress = (0, exports.progressBar)('RESTORE', total);
    try {
        for (var _h = true, data_2 = __asyncValues(data), data_2_1; data_2_1 = yield data_2.next(), _e = data_2_1.done, !_e;) {
            _g = data_2_1.value;
            _h = false;
            try {
                const val = _g;
                progress === null || progress === void 0 ? void 0 : progress.tick();
            }
            finally {
                _h = true;
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (!_h && !_e && (_f = data_2.return)) yield _f.call(data_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    redis.disconnect();
});
exports.restore = restore;
const sync = (options) => __awaiter(void 0, void 0, void 0, function* () {
    var _j, e_3, _k, _l;
    const { sourceUri, targetUri, pattern, bulkSize, useTtl, logger } = new IRedisDRS.sync(options);
    const redis = new index_1.RedisDRS({ path: sourceUri, logger });
    const data = yield redis.sync({
        targetRedisOptions: { path: targetUri, logger },
        pattern,
        bulkSize,
        useTtl,
    });
    const total = (yield data.next()).value;
    const progress = (0, exports.progressBar)('SYNC', total);
    try {
        for (var _m = true, data_3 = __asyncValues(data), data_3_1; data_3_1 = yield data_3.next(), _j = data_3_1.done, !_j;) {
            _l = data_3_1.value;
            _m = false;
            try {
                const val = _l;
                progress === null || progress === void 0 ? void 0 : progress.tick();
            }
            finally {
                _m = true;
            }
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (!_m && !_j && (_k = data_3.return)) yield _k.call(data_3);
        }
        finally { if (e_3) throw e_3.error; }
    }
    redis.disconnect();
});
exports.sync = sync;
//# sourceMappingURL=utils.js.map