"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEmitter = void 0;
function createEmitter() {
    const queue = [];
    let resolve;
    const push = (p) => {
        queue.push(p);
        if (resolve) {
            resolve();
            resolve = null;
        }
    };
    const emitError = (e) => push(Promise.reject(e));
    return {
        emit: (v) => push(Promise.resolve(v)),
        throw: emitError,
        [Symbol.asyncIterator]: () => ({
            next: () => __awaiter(this, void 0, void 0, function* () {
                while (!queue.length) {
                    yield new Promise((...a) => ([resolve] = a));
                }
                return { value: yield queue.pop(), done: false };
            }),
            throw: emitError,
        }),
    };
}
exports.createEmitter = createEmitter;
//# sourceMappingURL=utils.js.map