/// <reference types="node" />
import Redis from 'ioredis';
import EventEmitter from 'events';
import * as IRedisDRS from './model';
export declare class RedisDRS extends Redis {
    version: string;
    private havePttl;
    private logger;
    constructor(options: IRedisDRS.options);
    init(): Promise<void>;
    getOne(key: string): Promise<IRedisDRS.item>;
    setOne(item: IRedisDRS.item | Promise<IRedisDRS.item>, useTtl?: boolean): Promise<string | undefined>;
    gelAll({ action, pattern, bulkSize, }: {
        action?: string;
        pattern?: string;
        bulkSize?: number;
    }): Promise<{
        getData: () => Promise<void>;
        emitter: EventEmitter;
    }>;
    dump(options: IRedisDRS.dump): AsyncGenerator<number | void | IRedisDRS.item, void, undefined>;
    restore(options: IRedisDRS.restore): AsyncGenerator<string | number, void, undefined>;
    sync(options: IRedisDRS.sync): AsyncGenerator<number | void | IRedisDRS.item, void, undefined>;
}
