"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
};
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedisDRS = void 0;
const ioredis_1 = __importDefault(require("ioredis"));
const events_1 = __importDefault(require("events"));
const file_1 = require("./helpers/file");
const IRedisDRS = __importStar(require("./model"));
events_1.default.defaultMaxListeners = 0;
class RedisDRS extends ioredis_1.default {
    constructor(options) {
        const { path, port, host, options: _options } = options || {};
        if (path && !_options)
            super(path);
        else if (port && !host && !_options)
            super(port);
        else if (_options && !port && !host)
            super(_options);
        else if (path && _options)
            super(path, _options);
        else if (port && _options && !host)
            super(port, _options);
        else if (port && host && !_options)
            super(port, host);
        else if (port && host && _options)
            super(port, host, _options);
        else
            super();
        this.version = '';
        this.havePttl = false;
        this.logger = options.logger === true ? console.info : () => { };
    }
    init() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const info = yield this.info();
            const { version } = ((_a = info.match(/redis_version:(?<version>[0-9.]+)/)) === null || _a === void 0 ? void 0 : _a.groups) || {};
            this.version = version;
            this.havePttl = Number(version.slice(0, 3)) > 2.6;
        });
    }
    getOne(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const keyType = yield this.type(key);
            const p = this.pipeline();
            p.watch(key);
            p.type(key);
            if (this.havePttl)
                p.pttl(key);
            else
                p.ttl(key);
            switch (keyType) {
                case 'string':
                    p.get(key);
                    break;
                case 'list':
                    p.lrange(key, 0, -1);
                    break;
                case 'set':
                    p.smembers(key);
                    break;
                case 'zset':
                    p.zrange(key, 0, -1);
                    break;
                case 'hash':
                    p.hgetall(key);
                    break;
                default:
                    throw new Error(`Unknown type=${keyType}`);
            }
            let [[], [, type], [, ttl], [, value]] = (yield p.exec()) || [];
            if (type != keyType) {
                throw new Error(`Type changed from ${keyType} to ${type}`);
            }
            let expireAt = -1;
            if (this.havePttl && ttl > 0)
                ttl = ttl / 1000.0;
            if (ttl > 0)
                expireAt = Date.now() + ttl;
            return { type, key, ttl, expireAt, value };
        });
    }
    setOne(item, useTtl) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            item = yield item;
            let value = item.value;
            const p = this.pipeline();
            p.del(item.key);
            switch (item.type) {
                case 'string':
                    p.set(item.key, value);
                    break;
                case 'list':
                    for (const val of value) {
                        p.rpush(item.key, val);
                    }
                    break;
                case 'set':
                    for (const val of value) {
                        p.sadd(item.key, val);
                    }
                    break;
                case 'zset':
                    for (const [score, val] of value.entries()) {
                        p.zadd(item.key, score, val);
                    }
                    break;
                case 'hash':
                    p.hset(item.key, value);
                    break;
                default:
                    throw new Error(`Unknown type=${item.type}`);
            }
            if (item.ttl > 0) {
                if (useTtl) {
                    if (Number.isInteger(item.ttl)) {
                        p.expire(item.key, item.ttl);
                    }
                    else {
                        p.pexpire(item.key, +item.ttl * 1000);
                    }
                }
                else {
                    if (item.expireAt) {
                        if (Number.isInteger(item.expireAt)) {
                            p.expireat(item.key, item.expireAt);
                        }
                        else {
                            p.pexpireat(item.key, +item.expireAt * 1000);
                        }
                    }
                }
            }
            const [error] = (yield p.exec()) || [];
            return (_a = error === null || error === void 0 ? void 0 : error.at(0)) === null || _a === void 0 ? void 0 : _a.message;
        });
    }
    gelAll({ action = 'GET_ALL', pattern = '*', bulkSize = 1000, }) {
        return __awaiter(this, void 0, void 0, function* () {
            const emitter = new events_1.default();
            const getData = () => __awaiter(this, void 0, void 0, function* () {
                let keys = yield this.keys(pattern);
                emitter.emit('keys', keys);
                let pool = [];
                for (const key of keys) {
                    try {
                        const data = this.getOne(key);
                        emitter.emit('data', data);
                        pool.push(data);
                        if (pool.length >= bulkSize) {
                            yield Promise.all(pool);
                            pool = [];
                        }
                    }
                    catch (error) {
                        const message = (error === null || error === void 0 ? void 0 : error.message) || (error === null || error === void 0 ? void 0 : error.stack) || error;
                        this.logger(`[${action}] error while get [KEY:${key}] [ERROR:${message}]`);
                    }
                }
                yield Promise.all(pool);
                emitter.emit('end');
                emitter.removeAllListeners();
            });
            return { getData, emitter };
        });
    }
    // @ts-ignore
    dump(options) {
        return __asyncGenerator(this, arguments, function* dump_1() {
            const action = 'DUMP';
            yield __await(this.init());
            this.logger(`[${action}] redis version: ${this.version}`);
            const { filePath, pattern, bulkSize } = new IRedisDRS.dump(options);
            const stream = (0, file_1.writeStream)(filePath);
            this.logger(`[${action}] Get all keys for pattern: ${pattern}`);
            const { getData, emitter } = yield __await(this.gelAll({
                action,
                pattern,
                bulkSize,
            }));
            const pool = [];
            let dataPool = [];
            let streamPool = [];
            let resolve;
            let promise = new Promise((r) => (resolve = r));
            let done = false;
            emitter
                .on('keys', (keys) => {
                dataPool.push(keys.length);
                this.logger(`[${action}] Total keys: ${keys.length}`);
            })
                .on('data', (data) => __awaiter(this, void 0, void 0, function* () {
                dataPool.push(data);
                streamPool.push(stream.write(data));
                resolve();
                promise = new Promise((r) => (resolve = r));
            }))
                .on('error', (error) => {
                this.logger(`[${action}] Failed with error: ${error}`);
            })
                .on('end', () => __awaiter(this, void 0, void 0, function* () {
                yield Promise.allSettled(streamPool);
                yield Promise.allSettled(pool);
                done = true;
                resolve();
                stream.end();
                this.logger(`[${action}] Finished successfully`);
                emitter.removeAllListeners();
            }));
            pool.push(getData());
            while (!done) {
                yield __await(promise);
                yield __await(yield* __asyncDelegator(__asyncValues(dataPool)));
                dataPool = [];
            }
        });
    }
    // @ts-ignore
    restore(options) {
        return __asyncGenerator(this, arguments, function* restore_1() {
            const action = 'RESTORE';
            yield __await(this.init());
            this.logger(`[${action}] redis version: ${this.version}`);
            const { filePath, useTtl, bulkSize } = new IRedisDRS.restore(options);
            const callback = (index, line) => __awaiter(this, void 0, void 0, function* () {
                const item = JSON.parse(line);
                try {
                    yield this.setOne(item, useTtl);
                }
                catch (error) {
                    const message = (error === null || error === void 0 ? void 0 : error.message) || (error === null || error === void 0 ? void 0 : error.stack) || error;
                    emitter.emit('error', message);
                    emitter.removeAllListeners();
                    this.logger(`[${action}] error while set [LINE:${line}] [ERROR:${message}]`);
                }
            });
            const pool = [];
            const { emitter, reader } = (0, file_1.readStream)({
                filePath,
                bulkSize,
                callback,
            });
            let results = [];
            let resolve;
            let promise = new Promise((r) => (resolve = r));
            let done = false;
            emitter
                .on('linesCount', (linesCount) => {
                results.push(linesCount);
                this.logger(`[${action}] Total keys: ${linesCount}`);
            })
                .on('line', (index, line) => {
                results.push(line);
                resolve();
                promise = new Promise((r) => (resolve = r));
            })
                .on('error', (error) => {
                this.logger(`[${action}] Failed with error: ${error}`);
            })
                .on('end', () => __awaiter(this, void 0, void 0, function* () {
                yield Promise.allSettled(pool);
                done = true;
                resolve();
                this.logger(`[${action}] Finished successfully`);
                emitter.removeAllListeners();
            }));
            pool.push(reader());
            while (!done) {
                yield __await(promise);
                yield __await(yield* __asyncDelegator(__asyncValues(results)));
                results = [];
            }
        });
    }
    // @ts-ignore
    sync(options) {
        return __asyncGenerator(this, arguments, function* sync_1() {
            const action = 'SYNC';
            yield __await(this.init());
            this.logger(`[${action}] redis version: ${this.version}`);
            const { targetRedisOptions, pattern, bulkSize, useTtl } = new IRedisDRS.sync(options);
            const targetRedis = new RedisDRS(targetRedisOptions);
            this.logger(`[${action}] Get all keys for pattern: ${pattern}`);
            const { getData, emitter } = yield __await(this.gelAll({
                action,
                pattern,
                bulkSize,
            }));
            const pool = [];
            let dataPool = [];
            let syncPool = [];
            let resolve;
            let promise = new Promise((r) => (resolve = r));
            let done = false;
            emitter
                .on('keys', (keys) => {
                dataPool.push(keys.length);
                this.logger(`[${action}] Total keys: ${keys.length}`);
            })
                .on('data', (data) => __awaiter(this, void 0, void 0, function* () {
                dataPool.push(data);
                syncPool.push(targetRedis
                    .setOne(data, useTtl)
                    .catch((error) => __awaiter(this, void 0, void 0, function* () {
                    data = JSON.stringify(yield data);
                    const message = (error === null || error === void 0 ? void 0 : error.message) || (error === null || error === void 0 ? void 0 : error.stack) || error;
                    emitter.emit('error', message);
                    emitter.removeAllListeners();
                    this.logger(`[${action}] error while set [DATA:${data}] [ERROR:${message}]`);
                })));
                resolve();
                promise = new Promise((r) => (resolve = r));
            }))
                .on('error', (error) => {
                this.logger(`[${action}] Failed with error: ${error}`);
            })
                .on('end', () => __awaiter(this, void 0, void 0, function* () {
                yield Promise.allSettled(syncPool);
                yield Promise.allSettled(pool);
                done = true;
                resolve();
                targetRedis.disconnect();
                this.logger(`[${action}] Finished successfully`);
                emitter.removeAllListeners();
            }));
            pool.push(getData());
            while (!done) {
                yield __await(promise);
                yield __await(yield* __asyncDelegator(__asyncValues(dataPool)));
                dataPool = [];
            }
        });
    }
}
exports.RedisDRS = RedisDRS;
//# sourceMappingURL=index.js.map