import { RedisOptions } from 'ioredis';
export interface options {
    path?: string;
    port?: number;
    host?: string;
    options?: RedisOptions;
    logger?: boolean;
}
export type keyType = 'string' | 'list' | 'set' | 'zset' | 'hash';
export interface item {
    type: keyType;
    key: string;
    ttl?: any;
    expireAt?: number;
    value: any;
}
export declare class dump {
    filePath: string;
    pattern?: string;
    bulkSize?: number;
    constructor(options: dump);
}
export declare class restore {
    filePath: string;
    useTtl?: boolean;
    bulkSize?: number;
    constructor(options: restore);
}
export declare class sync {
    targetRedisOptions: options;
    pattern?: string;
    useTtl?: boolean;
    bulkSize?: number;
    constructor(options: sync);
}
export interface IReadStream {
    filePath: string;
    bulkSize?: number;
    callback: (index: number, line: string) => Promise<void>;
}
